// Copyright (C) 2000 Nicholas Schmitt nick@math.umass.edu

#ifndef stl_INCLUDED
#define stl_INCLUDED

#include <vector.h>

namespace base {

/**
   fill a vector with 'count' 'points'.

   file stl.H
*/
template<class A>
void
fill( vector<A> &vect, A const &point, size_t count )
{
  vect.clear();
  vect.reserve(count);

  size_t i;
  for ( i = 0; i < count; i++ )
  {
    vect.push_back(point);
  }
}


/**
   fill a matrix with 'i_count'-by-'j_count' 'points'.

   file stl.H
*/
template<class A>
void
fill( vector<vector<A> > &matrix, A const &point,
                 size_t i_count, size_t j_count )
{
  matrix.clear();
  matrix.reserve(i_count);

  vector<A> vect;
  fill( vect, point, j_count );
  fill( matrix, vect, i_count );
}

} // namespace base

#endif // !stl_INCLUDED
