// Copyright (C) 2000 Nicholas Schmitt nick@math.umass.edu

#include <stdio.h>
#include "Timer.H"

namespace base {

void
Timer::
read(
  long &user_time,
  long &system_time,
  long &elapsed_time ) const
{
  tms system_time1;
  clock_t elapsed_time1 = times( &system_time1 );

  user_time = system_time1.tms_utime - system_time0.tms_utime;
  system_time = system_time1.tms_stime - system_time0.tms_stime;
  elapsed_time = elapsed_time1 - elapsed_time0;
}

void
Timer::
read(
  float &user_time,
  float &system_time,
  float &elapsed_time ) const
{
  long user_time_, system_time_, elapsed_time_;
  read( user_time_, system_time_, elapsed_time_ );
  
  user_time = (float)user_time_ / (float)CLK_TCK;
  system_time = (float)system_time_ / (float)CLK_TCK;
  elapsed_time = (float)elapsed_time_ / (float)CLK_TCK;
}

void
Timer::
read(
  string &user_time,
  string &system_time,
  string &elapsed_time ) const
{
  float user_time_, system_time_, elapsed_time_;
  read( user_time_, system_time_, elapsed_time_ );
  
  char t[100];
  sprintf( t, "%.2f", user_time_ );
  user_time = t;
  sprintf( t, "%.2f", system_time_ );
  system_time = t;
  sprintf( t, "%.2f", elapsed_time_ );
  elapsed_time = t;
}

} // namespace base
