// Copyright (C) 2000 GANG http://www.gang.umass.edu
#ifndef Polygon_INCLUDED
#define Polygon_INCLUDED

#include <iostream.h>
#include <vector.h>
#include "System.H"
#include "curve.H"

namespace curve {

/*
  --------------------------------------------
  class Polygon
  --------------------------------------------
*/

class Polygon
{
public:
  Polygon( /*std*/::vector<Point> const &polygon ) :
      _polygon(polygon),
      _turning_number( UNDEFINED_INT )
    {compute();}
  ~Polygon() {}

//  void clear() { _polygon.clear(); }
  uint size() const { return _polygon.size(); }
  bool empty() const { return _polygon.empty(); }
  Point const &operator[]( uint n ) const { return _polygon[n]; }
  /*std*/::vector<Point> const &polygon() const { return _polygon; }
//  /*std*/::vector<Point> &polygon() { return _polygon; }
  int turning_number() const { return _turning_number; }
  void rescale( real s );

protected:
  void compute() throw ( Exception );
  void compute_turning_number()  throw ( Exception );
  void jiggle();

private:
  /*std*/::vector<Point> _polygon;
  int _turning_number;

  // disabled
  Polygon &operator=( Polygon const & ) { return *this; }
};

} // namespace curve

#endif
