// Copyright (C) 2000 GANG http://www.gang.umass.edu
#ifndef curve_INCLUDED
#define curve_INCLUDED

#include <stddef.h>
#include <limits.h>
#include "Vector2.H"

namespace curve {
using namespace math;

/*
  --------------------------------------------
  typedefs, enums, global functions
  --------------------------------------------
*/

typedef size_t uint;
typedef double real;
typedef vector2<real> Point;
extern uint const UNDEFINED_UINT;
extern int const UNDEFINED_INT;
enum bool3 { FALSE, TRUE, UNDEFINED_BOOL };
enum Exception { ERR_INTERNAL, ERR_POLYGON, ERR_CURVE, ERR_FACES, ERR_DEGREE };

template <class T>
inline uint prev_( uint n, T const &t )
{ return ( n == 0 ? t.size() - 1: n - 1 ); }
template <class T>
inline uint next_( uint n, T const &t )
{ return ( n == t.size() - 1 ? 0 : n + 1 ); }

template <>
inline uint prev_( uint n, uint const &mod )
{ return ( n == 0 ? mod - 1: n - 1 ); }

template <>
inline uint next_( uint n, uint const &mod )
{ return ( n == mod - 1 ? 0 : n + 1 ); }


} // namespace curve
 
#endif
