// Copyright (C) 2000 GANG www.gang.umass.edu

#include <stdlib.h>
#include <getopt.h>
#include <iostream.h>
#include "System.H"
#include "Use.h"
#include "Immersion.H"

static void version();
static void help();
static void usage(char=0,bool=false);


int
main( int argc, char *argv[] )
{
  base::System->name( "curve" );

  int verbosity = 0;
  USE(verbosity);

  // get command line options
  int c;
  for (;;)
  {
    c = getopt(argc, argv, ":c:hHq:vV" );
    if ( c == -1 ) { break;}
    else if ( c == '?' ) { usage(optopt); }
    else if ( c == ':' ) { usage(optopt,true); }
    else if ( c == 'h' || c == 'H' ) { help(); }
    else if ( c == 'v' || c == 'V' ) { version(); }
    else if ( c == 'q' ) { verbosity = atoi( optarg ); }
  }

  // die if no input file named
  if ( argc - optind != 0 ) { usage(); }

  // version header
  /*std*/::cout << base::System->name() << "-" << VERSION
       << " (c) 2000 GANG www.gang.umass.edu\n";
  /*std*/::cout.flush();

  {
  curve::Immersion C(600, 600, argc, argv);
  C.loop();
  }
  return 0;
}

void
version()
{
  /*std*/::cout << base::System->name() << "-" << VERSION
       << " (c) 2000 GANG www.gang.umass.edu\n";
  exit(0);
}

void
help()
{
  /*std*/::cout << base::System->name() << "-" << VERSION
       << " (c) 2000 GANG www.gang.umass.edu\n"
       << "usage: " << base::System->name() << " OPTIONS\n"
       << "  -v, -V: print version string and exit\n"
       << "  -h, -H: print usage message and exit\n";
  exit(0);
}

void
usage(char option, bool error_type)
{
  if (option == 0 )
  {
    /*std*/::cerr << "usage: " << base::System->name() << " OPTIONS\n";
  }
  else
  {
    /*std*/::cerr << base::System->name() << ": ";
    if ( error_type )
    {
      /*std*/::cerr << "missing argument to option \'" << option << "\'\n";
    }
    else
    {
      /*std*/::cerr << "unknown option \'" << option << "\'\n";
    }
  }
  exit(1);
}
